#include "header\gba.h"
#include "header\bg.h"
#include "header\timer.h"
#include "header\dma.h"
#include "header\irq.h"
#include "header\sound.h"
#include "header\sprite.h"
#include "header\blend.h"

#include "lib.h"
#include "iwram.h"
#include "irq.h"
#include "syscall.h"

#include "resource.h"
//#include "resource\BGFont.h"
#include "resource\BitMapFont.h"

//---------------------------------------------------------------------------
//Q[̐is
#define GAME_STATE_READY  1		//ˏ
#define GAME_STATE_PULL   2		//Ђς
#define GAME_STATE_FREE   3		//
#define GAME_STATE_BACK   4		//߂
#define GAME_STATE_HIT    5		//
#define GAME_STATE_JUMP   6		//
#define GAME_STATE_JUDGE  7		//
#define GAME_STATE_RESET  8		//Q[

//ł_̈ړp
#define STICK_VECT_UP     0x01
#define STICK_VECT_DOWN   0x02
#define STICK_VECT_RIGHT  0x04
#define STICK_VECT_LEFT   0x08
#define STICK_VECT_NONE   0x00

//ł_̖߂鎞̃Xs[h
#define STICK_BACK_SPEED  1

#define COLOR_PINK        RGB(31,17,19)
#define COLOR_BLACK       RGB( 0, 0, 0)
#define COLOR_GREEN       RGB( 0,17, 0)
//---------------------------------------------------------------------------

typedef struct {
	u16 x;
	u16 y;
	u16 r;				//a
}ST_CIRCLE;

ST_CIRCLE LAND;		//nłʒu(sNF)


typedef struct {
	f32 x;
	f32 y;
	u16 r;				//a
	f32 txv;			//ړ
	f32 tyv;
	u16 SprNo;
	u16 SprTile;
	u16 SprSize;
	u16 SprForm;
	
	u16 SprRotateNo;
	u16 SprScale;		//gk
	u16 SprAngle;		//]

	u8  vect;			//ړ
	s16 MoveCnt;
}ST_CHR;

ST_CHR POY;				//F
ST_CHR STICK;			//ł_


//---------------------------------------------------------------------------

u8 StageCnt;
u8 GameStateFlag;

//---------------------------------------------------------------------------
void Init();
void InitStage();

void StateReadyProcess();
void StatePullProcess();
void StateFreeProcess();
void StateBackProcess();
void StateJumpProcess();
void StateJudgeProcess();

void MoveProcess();

void Stick();
void MoveStick(ST_CHR* p);

u8   ChkMoveStick(ST_CHR* p);
u8   ChkHitStickAndPOY();
u8   ChkHitLandAndPOY();
u8   ChkKeyPushA();

void DrawStageMessage();
void DrawMessage(char msg[]);
void DrawLand();
void DrawPOY();
void DrawStick();
void DrawBlackLine();
void DrawGreenLine();

void ChangeAnglePOY();

void TimerStart();
void TimerStop();

void IRQUserHandler();
void IRQUserSetup();
//---------------------------------------------------------------------------
int main(void)
{
Restart:
	
	Init();
	InitStage();
	SetMode(MODE_3 | BG2_ENABLE | OBJ_ENABLE | OBJ_MAP_2D);

	TimerStart();

	for(;;)
	{
		WaitForVsync();

		switch(GameStateFlag)
		{
			//̏͂悭ȂȂEEɂP[
			case GAME_STATE_READY: StateReadyProcess(); break;
			case GAME_STATE_PULL:  StatePullProcess();  break;
			case GAME_STATE_FREE:  StateFreeProcess();  break;
			case GAME_STATE_BACK:  StateBackProcess();  break;
			case GAME_STATE_JUMP:  StateJumpProcess();  break;
			case GAME_STATE_JUDGE: StateJudgeProcess(); break;
			case GAME_STATE_RESET: goto Restart;        break;
			default: break;
		}
	}
	return 0;
}
//---------------------------------------------------------------------------
void Init()
{
	//EFCgRg[
	REG_WSCNT = CST_ROM0_1ST_3WAIT | CST_ROM0_2ND_1WAIT;

	//IRQZbg
	IRQUserSetup();

	//L[
	KeyInit();

	//Mode3 Font
	Mode3SetBitMapFont((u8*)&BitMapFont, 8,8);

	//Sprite
	SpriteInit();
	SpriteSetPal16((u16*)&spr_pal_bin);
	SpriteSetData ((u16*)&spr_img_bin, 4096);

	//ʔwi
	Mode3DrawBox(0, 0, 240, 160, COLOR_GREEN);

	//Q[֌W̏
	StageCnt  = 1;
	GameStateFlag = GAME_STATE_READY;

	POY.x       = 256;
	POY.y       = 256;
	POY.r       = 16;
	POY.SprNo   = 1;
	POY.SprTile = 512;
	POY.SprSize = SP_SIZE_32;
	POY.SprForm = SP_SQUARE;

	POY.SprRotateNo = 0;
	POY.SprScale    = 128;
	POY.SprAngle    = 0;
	
	SpriteSetRotateFlag(POY.SprNo, POY.SprRotateNo, SP_SIZE_DOUBLE);
	SpriteSetSize(POY.SprNo, POY.SprSize, POY.SprForm, SP_COLOR_16);
	SpriteSetChr (POY.SprNo, POY.SprTile);

	ChangeAnglePOY();


	STICK.x       = 256;
	STICK.y       = 256;
	STICK.r       = 8;
	STICK.SprNo   = 0;
	STICK.SprTile = 528;
	STICK.SprSize = SP_SIZE_16;
	STICK.SprForm = SP_SQUARE;

	SpriteSetSize(STICK.SprNo, STICK.SprSize, STICK.SprForm, SP_COLOR_16);
	SpriteSetChr (STICK.SprNo, STICK.SprTile);
}
//---------------------------------------------------------------------------
void InitStage()
{
	//̕\
	LAND.x = 50;
	LAND.y = 50;
	LAND.r = 20;
	DrawLand();

	//F̕\
	POY.x = 100;
	POY.y = 50;
	DrawPOY();

	//ł_̕\
	STICK.x = POY.x + POY.r*2 - STICK.r;
	STICK.y = POY.y + POY.r*2 - STICK.r;
	DrawStick();

	//Xe[WbZ[W̕\
	DrawStageMessage();
}
//---------------------------------------------------------------------------
void DrawStageMessage()
{
	char msg[40];
	bprintf(msg, "Stage: %2d", StageCnt);
	Mode3DrawBitMapStr(1,19,(u8*)msg);
}
//---------------------------------------------------------------------------
void DrawMessage(char msg[])
{
	Mode3DrawBitMapStr(17,19,(u8*)msg);
}
//---------------------------------------------------------------------------
void DrawLand()
{
	Mode3DrawFillCircle(LAND.x, LAND.y, LAND.r, COLOR_PINK);
}
//---------------------------------------------------------------------------
void DrawPOY()
{
	SpriteMove(POY.SprNo, POY.x, POY.y);
}
//---------------------------------------------------------------------------
void DrawStick()
{
	SpriteMove(STICK.SprNo, STICK.x, STICK.y);
}
//---------------------------------------------------------------------------
void ChangeAnglePOY()
{
	POY.SprAngle++;		//POY.SprAngle̕ϐu8Ȃ̂ŁA0`255JԂ܂
	SpriteSetRotate(POY.SprRotateNo, POY.SprAngle, POY.SprScale);
}
//---------------------------------------------------------------------------
void IRQUserSetup()
{
	REG_IME = IRQ_MASTER_OFF;

	REG_INTERUPT  = (u32)IRQUserHandler;
	REG_IE       |= IRQ_BIT_TIMER0;

	REG_IME = IRQ_MASTER_ON;
}
//---------------------------------------------------------------------------
void IRQUserHandler(){
	REG_IME  = IRQ_MASTER_OFF;
	u16 Flag = REG_IF;

	if(Flag & IRQ_BIT_TIMER0)
	{
		ChangeAnglePOY();
		REG_TM0D = 0xF000;
	}

	REG_IF  = Flag;
	REG_IME = IRQ_MASTER_ON;
}
//---------------------------------------------------------------------------
void TimerStart()
{
	REG_TM0D   = 0xF000;
	REG_TM0CNT = TM_ENABLE | TM_FREQ_PER_64 | TM_USEIRQ;
}
//---------------------------------------------------------------------------
void TimerStop()
{
	REG_TM0D   = 0x0000;
	REG_TM0CNT = TM_DISABLE;
}
//---------------------------------------------------------------------------
//ł_
void Stick()
{
	u8 Key = KeyInput();

	STICK.vect = STICK_VECT_NONE;

	if(Key & KEY_UP   ) STICK.vect |= STICK_VECT_UP;
	if(Key & KEY_DOWN ) STICK.vect |= STICK_VECT_DOWN;
	if(Key & KEY_LEFT ) STICK.vect |= STICK_VECT_LEFT;
	if(Key & KEY_RIGHT) STICK.vect |= STICK_VECT_RIGHT;

	if( ChkMoveStick(&STICK) != TRUE )
	{
		STICK.vect = STICK_VECT_NONE;
	}
}
//---------------------------------------------------------------------------
//ړ͈ړ\`FbN
u8 ChkMoveStick(ST_CHR* p)
{
	s16 tx1 = p->x;
	s16 ty1 = p->y;

	if(p->vect & STICK_VECT_UP   ) ty1--;
	if(p->vect & STICK_VECT_DOWN ) ty1++;
	if(p->vect & STICK_VECT_LEFT ) tx1--;
	if(p->vect & STICK_VECT_RIGHT) tx1++;

	s16 tx2 = tx1 + p->r*2 - 1;
	s16 ty2 = ty1 + p->r*2 - 1;

	if(tx1<   0 || ty1<   0) return FALSE;
	if(tx2>=240 || ty2>=160) return FALSE;

	return TRUE;
}
//---------------------------------------------------------------------------
void MoveStick(ST_CHR* p)
{
	if(p->vect & STICK_VECT_UP   ) p->y--;
	if(p->vect & STICK_VECT_DOWN ) p->y++;
	if(p->vect & STICK_VECT_LEFT ) p->x--;
	if(p->vect & STICK_VECT_RIGHT) p->x++;
}
//---------------------------------------------------------------------------
void MoveProcess()
{
	//ł_
	if(STICK.vect != STICK_VECT_NONE)
	{
		DrawGreenLine();
		MoveStick(&STICK);
		DrawStick();
		DrawBlackLine();
	}
}
//---------------------------------------------------------------------------
void DrawBlackLine()
{
	Mode3DrawLine(POY.x+POY.r*2, POY.y+POY.r*2, STICK.x+STICK.r-1, STICK.y+STICK.r-1, COLOR_BLACK);
}
//---------------------------------------------------------------------------
void DrawGreenLine()
{
	Mode3DrawLine(POY.x+POY.r*2, POY.y+POY.r*2, STICK.x+STICK.r-1, STICK.y+STICK.r-1, COLOR_GREEN);
}
//---------------------------------------------------------------------------
u8 ChkHitStickAndPOY()
{
	if( HitChkCircle(POY.x+POY.r*2, POY.y+POY.r*2, POY.r,
	                 STICK.x+STICK.r-1, STICK.y+STICK.r-1, STICK.r) == TRUE )
	{
		return TRUE;
	}
	return FALSE;
}
//---------------------------------------------------------------------------
u8 ChkHitLandAndPOY()
{
	if( HitChkCircle(POY.x+POY.r*2, POY.y+POY.r*2, POY.r,
	                 LAND.x, LAND.y, LAND.r ) == TRUE )
	{
		return TRUE;
	}
	return FALSE;
}

//---------------------------------------------------------------------------
u8 ChkKeyPushA()
{
	u8 Key = KeyInput();

	if(Key & KEY_A)
	{
		return TRUE;
	}
	return FALSE;
}
//---------------------------------------------------------------------------
void StateReadyProcess()
{
	if ( ChkKeyPushA() == TRUE )
	{
		//ł_IWFɕς
		STICK.SprTile = 530;
		SpriteSetChr (STICK.SprNo, STICK.SprTile);

		GameStateFlag = GAME_STATE_PULL;
	}
}
//---------------------------------------------------------------------------
void StatePullProcess()
{
	MoveProcess();
	Stick();

	if ( ChkKeyPushA() == FALSE )
	{
		if ( ChkHitStickAndPOY() == TRUE )
		{
			//ł_𔒐Fɕς
			STICK.SprTile = 528;
			SpriteSetChr (STICK.SprNo, STICK.SprTile);

			//ȌԂɖ߂
			GameStateFlag = GAME_STATE_READY;
		}
		else
		{
			GameStateFlag = GAME_STATE_FREE;
		}
	}
}
//---------------------------------------------------------------------------
void StateFreeProcess()
{
	//ł_FɓĂvZ
	u8 angle  = GetAngle( (POY.x+POY.r*2) - (STICK.x+STICK.r-1), (POY.y+POY.r*2) - (STICK.y+STICK.r-1) );
	STICK.txv = STICK_BACK_SPEED * _Cos(angle);
	STICK.tyv = STICK_BACK_SPEED * _Sin(angle);
	STICK.MoveCnt = 0;

	GameStateFlag = GAME_STATE_BACK;
}
//---------------------------------------------------------------------------
void StateBackProcess()
{
	DrawGreenLine();

	//ł_̈ʒuɖ߂
	STICK.x += STICK.txv;
	STICK.y += STICK.tyv;
	STICK.MoveCnt++;

	DrawStick();
	DrawBlackLine();

	if( ChkHitStickAndPOY() == TRUE )
	{
		DrawGreenLine();

		//ł_̈ړʂƈړڂ
		POY.txv = STICK.txv;
		POY.tyv = STICK.tyv;
		POY.MoveCnt = STICK.MoveCnt;

		POY.SprTile = 520;		//JɕύX
		SpriteSetChr (POY.SprNo, POY.SprTile);

		GameStateFlag = GAME_STATE_JUMP;
	}
}
//---------------------------------------------------------------------------
void StateJumpProcess()
{
	if(POY.MoveCnt-- > 0)
	{
		POY.x += POY.txv;
		POY.y += POY.tyv;
		DrawPOY();
	}
	else
	{
		GameStateFlag = GAME_STATE_JUDGE;
	}
}
//---------------------------------------------------------------------------
void StateJudgeProcess()
{
	if ( ChkHitLandAndPOY() == TRUE )
	{
		DrawMessage("Stage Clear");

		POY.SprTile = 516;		//ɂɕύX
		SpriteSetChr (POY.SprNo, POY.SprTile);

	}
	else
	{
		DrawMessage("Game Over");

		POY.SprTile = 524;		//RɕύX
		SpriteSetChr (POY.SprNo, POY.SprTile);
	}

	while( ChkKeyPushA() != TRUE ){}

	GameStateFlag = GAME_STATE_RESET;
}
